#include "stdafx.h"

#include <windows.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>
#include <iomanip>

using namespace std;

const int NUMBER_OF_USER_ACCESS = 3;
const int ROWS = 200;
const int COLUMNS = 256;
const unsigned short CELL_DATA_SIZE	= 1024;
const unsigned long	TIME_INTERVAL_MS = 15000;
const unsigned short MS_TO_SECONDS = 1000;

// Direccin virtual base de la memoria
LPVOID lpvBase; 

void ModifyData(BYTE* Data, int SizeInBytes)
{
	printf("\tModificando celda con direccin: %ph\n", Data);
	for (int i = 0; i < SizeInBytes; i++)
		Data[i] = rand()%256;
}

void PrintErrorAndExit(LPTSTR Reason)
{
	LPVOID lpMsgBuf;

	cerr<<"Error: " << Reason << " con cdigo " << GetLastError() << endl;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM 
			| FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), 
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);
	cerr << "Descripcin: " << (char*)lpMsgBuf << endl;
	LocalFree(lpMsgBuf);

	ExitProcess(1);
}

void UserAccess(int Row, int Col)
{
	DWORD Position = (Row*COLUMNS) + Col;
	LPVOID Address = (BYTE*)lpvBase + Position*CELL_DATA_SIZE;
	MEMORY_BASIC_INFORMATION mbi;
	LPVOID pVirtualAlloc;

	Completar

	if (mbi.State != MEM_COMMIT)
	{
		cout << "\tLa posicin (" << Row << ", " << Col << ") est slo reservada\n";

		Completar

		if (pVirtualAlloc == NULL)
			PrintErrorAndExit("Fallo al reservar y commit en VirtualAlloc");
		cout << "\tLa posicin (" << Row << ", " << Col << ") ha sido asignada\n";
	}
	else
	{
		cout << "\tLa posicin (" << Row << ", " << Col << ") ya est asignada\n";
	}
	ModifyData((BYTE*)Address, CELL_DATA_SIZE);
}

DWORD WINAPI SimulateUser(LPVOID lpParam)
{
	UNREFERENCED_PARAMETER(lpParam);

	int Col, Row, i, tr;

	for (i = 0; i < NUMBER_OF_USER_ACCESS; i++)
	{
		tr = rand()%10;
		cout << "\n\tEl usuario est reflexionando " << tr << " seg\n";
		Sleep(tr*MS_TO_SECONDS);		// Tiempo de reflexin
		Row = rand()%ROWS;
		Col = rand()%COLUMNS;
		cout << "\tEl usuario va a acceder a la posicin ("
			<< Row << ", " << Col << ")\n";
		UserAccess(Row,Col);
	}
	cout << "\n\tTermina la simulacin del usuario\n\n";

	return 0;
}

// Imprime la memoria libre
void PrintAvailableMemory()
{
	Completar
}

int _tmain(int argc, _TCHAR* argv[])
{
	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	SIZE_T MemSize;
	SYSTEM_INFO si;
	HANDLE hThread;
	BOOL bSuccess;                // flag

	srand((unsigned)time(NULL)); 	// establece la semilla del
								 								// generador de nmeros aleatorios

	GetSystemInfo(&si); 
	cout << "Hilo padre: Tamao de pgina: "<< si.dwPageSize << "bytes\n";
	PrintAvailableMemory();

	MemSize = ROWS*COLUMNS*CELL_DATA_SIZE;

	// Reservar tanta memoria como indique MemSize
	// Almacenar el valor de retorno en lpvBase
	Completar
	
	cout << "Hilo padre: Se han reservado con xito " << (int)MemSize/(1024*1024) << " MB\n";
	printf("Hilo padre: La direccin base es: %ph\n", lpvBase);
	PrintAvailableMemory();

	// Creacin del hilo de simulacin del usuario
	//*\OcultarCodigo{
	hThread = CreateThread(
					NULL,						// Atributos de seguridad
					0,							// Tamao de la pila por defecto
					SimulateUser,		// Direccin de la rutina
					NULL,						// Argumento a la rutina
					0,							// Opciones de creacin
					NULL);					// Retorna el identificador del hilo
	if ( hThread == NULL )
		PrintErrorAndExit("Fallo al crear el hilo");					
	//*}

	for (;;)
	{
		// Esperar 15 segundos o la muerte del hilo hijo
		if (WaitForSingleObject(hThread, TIME_INTERVAL_MS) == WAIT_OBJECT_0)
			break;
		PrintAvailableMemory();
	}
	CloseHandle(hThread);

	//Liberacin de la memoria
	Completar

	PrintAvailableMemory();

	return 0;
} 
